## mrcal 2.1

=== Makefile ===
PYTHON_VERSION_FOR_EXTENSIONS := 3

include mrbuild/Makefile.common.header

PROJECT_NAME := mrcal
ABI_VERSION  := 2
TAIL_VERSION := 0

# "git describe --tags" says things like "v2.0-17-gcef328f". This converts it to "v2.0"
_VERSION_STRIP_POST_TAG_ANNOTATIONS := s/-\d+-g[0-9a-f]{7}$$//
# I might have a tag such as "debian/2.0-1". This converts it to "2.0-1"
_VERSION_STRIP_LEADING_PATH         := s/^.*\///
# I might have a tag such as "v2.0". This converts it to "2.0"
_VERSION_STRIP_LEADING_V            := s/^v//g

# Custom version from git (or from debian/changelog if no git repo available)

# If user says "VERSION_USE_LATEST_TAG=1 make" I'll use the latest tag for the
# version, without annotations about the subsequent commits
_VERSION = $(shell test -d .git && \
  git describe --tags | \
    perl -pe '$(if $(VERSION_USE_LATEST_TAG),$(_VERSION_STRIP_POST_TAG_ANNOTATIONS)); \
              $(_VERSION_STRIP_LEADING_PATH);         \
              $(_VERSION_STRIP_LEADING_V);' || \
  < debian/changelog sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/; p; q;')
# Memoize. $(VERSION) will evaluate the result the first time, and use the
# cached result during subsequent calls
VERSION = $(if $(_VERSION_EXPANDED),,$(eval _VERSION_EXPANDED:=$$(_VERSION)))$(_VERSION_EXPANDED)

LIB_SOURCES +=			\
  mrcal.c			\
  mrcal-opencv.c		\
  poseutils.c			\
  poseutils-opencv.c		\
  poseutils-uses-autodiff.cc	\
  triangulation.cc

BIN_SOURCES +=					\
  test-gradients.c				\
  test/test-cahvor.c				\
  test/test-lensmodel-string-manipulation.c     \
  test/test-parser-cameramodel.c

LDLIBS    += -ldogleg

CFLAGS    += --std=gnu99
CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter
CCXXFLAGS += -march=native

mrcal.o test/test-cahvor.o: minimath/minimath_generated.h
minimath/minimath_generated.h: minimath/minimath_generate.pl
	./$< > $@.tmp && mv $@.tmp $@
EXTRA_CLEAN += minimath/minimath_generated.h

DIST_INCLUDE += \
	mrcal.h \
	mrcal_internal.h \
	basic_geometry.h \
	poseutils.h \
	triangulation.h
DIST_BIN :=					\
	mrcal-calibrate-cameras			\
	mrcal-convert-lensmodel			\
	mrcal-show-distortion-off-pinhole	\
	mrcal-show-splined-model-correction	\
	mrcal-show-projection-uncertainty	\
	mrcal-show-projection-diff		\
	mrcal-reproject-points			\
	mrcal-reproject-image			\
	mrcal-graft-models			\
	mrcal-to-cahvor				\
	mrcal-to-cameramodel			\
	mrcal-show-geometry			\
	mrcal-show-valid-intrinsics-region	\
	mrcal-is-within-valid-intrinsics-region \
	mrcal-triangulate			\
	mrcal-cull-corners                      \
	mrcal-show-residuals-board-observation  \
	mrcal-show-residuals                    \
	mrcal-stereo

# generate manpages from distributed binaries, and ship them. This is a hoaky
# hack because apparenly manpages from python tools is a crazy thing to want to
# do
DIST_MAN := $(addsuffix .1,$(DIST_BIN))

# parser
cameramodel-parser_GENERATED.c: cameramodel-parser.re mrcal.h
	re2c $< > $@.tmp && mv $@.tmp $@
LIB_SOURCES += cameramodel-parser_GENERATED.c
EXTRA_CLEAN += cameramodel-parser_GENERATED.c
cameramodel-parser_GENERATED.o: CCXXFLAGS += -fno-fast-math

ALL_NPSP_EXTENSION_MODULES := $(patsubst %-genpywrap.py,%,$(wildcard *-genpywrap.py))
ALL_PY_EXTENSION_MODULES   := _mrcal $(patsubst %,_%_npsp,$(ALL_NPSP_EXTENSION_MODULES))
%/:
	mkdir -p $@

######### python stuff
%-npsp-pywrap-GENERATED.c: %-genpywrap.py
	python3 $< > $@.tmp && mv $@.tmp $@
mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@

ALL_NPSP_C  := $(patsubst %,%-npsp-pywrap-GENERATED.c,$(ALL_NPSP_EXTENSION_MODULES))
ALL_NPSP_O  := $(patsubst %,%-npsp-pywrap-GENERATED.o,$(ALL_NPSP_EXTENSION_MODULES))
ALL_NPSP_SO := $(patsubst %,mrcal/_%_npsp$(PY_EXT_SUFFIX),$(ALL_NPSP_EXTENSION_MODULES))

EXTRA_CLEAN += $(ALL_NPSP_C)

# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=95635
$(ALL_NPSP_O): CFLAGS += -Wno-array-bounds

mrcal-pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@

PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)

# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
# and the compiler complains. But that's how Python does it! So I tell the
# compiler to chill
$(PYTHON_OBJECTS): CFLAGS += -Wno-cast-function-type
$(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)

# The python libraries (compiled ones and ones written in python) all live in
# mrcal/
DIST_PY3_MODULES := mrcal

all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
EXTRA_CLEAN += mrcal/*.so

include Makefile.doc
include Makefile.tests

include mrbuild/Makefile.common.footer

=== debian/changelog ===
mrcal (2.1-5build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 15:58:12 +0000

mrcal (2.1-5) unstable; urgency=medium

  * Test suite passes on arm64

 -- Dima Kogan <dkogan@debian.org>  Sun, 13 Feb 2022 19:29:22 -0800

mrcal (2.1-4) unstable; urgency=medium

  * Build works with a newer argparse

 -- Dima Kogan <dkogan@debian.org>  Sun, 13 Feb 2022 00:56:25 -0800

mrcal (2.1-3) unstable; urgency=medium

  * added build patch to diagnose an Ubuntu build failure

 -- Dima Kogan <dkogan@debian.org>  Sat, 12 Feb 2022 23:21:36 -0800

mrcal (2.1-2) unstable; urgency=medium

  * mrcal builds for non-amd64 architectures
  * mrcal is cross-buildable
  * mrcal builds packages for all the installed python versions

 -- Dima Kogan <dkogan@debian.org>  Mon, 24 Jan 2022 12:08:08 -0800

mrcal (2.1-1) unstable; urgency=medium

  * Initial release into Debian (Closes: #998795)

 -- Dima Kogan <dkogan@debian.org>  Fri, 19 Nov 2021 16:43:18 -0800

=== debian/control ===
Source: mrcal
Priority: optional
Section: devel
Build-Depends:
# Please do not "fix" to use debhelper-compat. I want this to remain compatible
# with older debian-based distros
 debhelper (>= 11),
 dh-python,
 libdogleg-dev (>= 0.15.4),
 libsuitesparse-dev (>= 1:4.5.2),
 perl:native, liblist-moreutils-perl:native,
 vnlog,
 chrpath,
 re2c (>= 2),
 python3-all-dev:any,
 libpython3-all-dev,
# These are for the tests only, so :native
 python3-gnuplotlib (>= 0.38) <!nocheck>,
 python3-numpysane (>= 0.35)  <!nocheck>,
 python3-opencv               <!nocheck>,
 python3-numpy                <!nocheck>,
 python3-scipy (>= 0.18)      <!nocheck>
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.6.0
Homepage: http://mrcal.secretsauce.net
Vcs-Git: https://salsa.debian.org/science-team/mrcal.git
Vcs-Browser: https://salsa.debian.org/science-team/mrcal
Testsuite: autopkgtest-pkg-python

Package: libmrcal2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the runtime C libraries

Package: mrcal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
         python3-mrcal (= ${binary:Version}),
         python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
         python3-scipy (>= 0.18),  python3-ipython,
         python3-opencv, python3,
         mrgingham (>= 1.5)
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the user-facing tools

Package: libmrcal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmrcal2 (= ${binary:Version})
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the development C libraries

Package: python3-mrcal
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
         ${python3:Depends},
         python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
         python3-opencv, python3-numpy, python3-scipy (>= 0.18),
         python3-shapely, python3-ipython,
# for image_transformation_map(), not for plotting
         python3-matplotlib
Provides: ${python3:Provides}
Description: Calibration and SFM library
 A photogrammetry toolkit that provides improved methods for making and using
 camera models (calibration, tracking, mapping, etc). The focus is on
 calibration and uncertainty propagation to produce the most accurate models
 possible. This package provides the Python interfaces

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export VERSION_USE_LATEST_TAG  = 1

%:
	dh $@ --with python3

# I build the python libraries for all the available python versions. The
# non-Python stuff shouldn't be rebuilt because Make should see that it's
# up-to-date
override_dh_auto_build:
	for v in `py3versions -s | sed s/python//g`; do		\
	  rm -f *pywrap*.o;					\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_build;	\
	done

# Similarly, I install everything, looping through all the available python
# versions, which could be more than just the default. All the non-python stuff
# will be installed multiple times, but it's the same files going to the same
# paths, so it hurts nothing
override_dh_auto_install:
	for v in `py3versions -s | sed s/python//g`; do		\
	  PYTHON_VERSION_FOR_EXTENSIONS=$$v dh_auto_install;	\
	done

override_dh_python3:
	dh_numpy3
	dh_python3

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make test-nosampling
endif

## mrcal 2.2

=== Makefile ===
# "0" or undefined means "false"
# everything else means  "true"

# libelas stereo matcher. Available in Debian/non-free. I don't want to depend
# on anything in non-free, so I default to not using libelas
USE_LIBELAS ?= 0


# convert all USE_XXX:=0 to an empty string
$(foreach v,$(filter USE_%,$(.VARIABLES)),$(if $(filter 0,${$v}),$(eval undefine $v)))
# to print them all: $(foreach v,$(filter USE_%,$(.VARIABLES)),$(warning $v = '${$v}'))



include mrbuild/Makefile.common.header

PROJECT_NAME := mrcal
ABI_VERSION  := 2
TAIL_VERSION := 2

VERSION := $(VERSION_FROM_PROJECT)

LIB_SOURCES +=			\
  mrcal.c			\
  mrcal-opencv.c		\
  mrcal-image.c			\
  poseutils.c			\
  poseutils-opencv.c		\
  poseutils-uses-autodiff.cc	\
  triangulation.cc

ifneq (${USE_LIBELAS},) # using libelas
LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
endif


BIN_SOURCES +=					\
  test-gradients.c				\
  test/test-cahvor.c				\
  test/test-lensmodel-string-manipulation.c     \
  test/test-parser-cameramodel.c

LDLIBS += -ldogleg -lfreeimage

ifneq (${USE_LIBELAS},) # using libelas
LDLIBS += -lelas
endif

CFLAGS    += --std=gnu99
CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter

mrcal.o test/test-cahvor.o: minimath/minimath_generated.h
minimath/minimath_generated.h: minimath/minimath_generate.pl
	./$< > $@.tmp && mv $@.tmp $@
EXTRA_CLEAN += minimath/minimath_generated.h

DIST_INCLUDE += \
	mrcal.h \
	mrcal-image.h \
	mrcal-internal.h \
	basic-geometry.h \
	poseutils.h \
	triangulation.h
DIST_BIN :=					\
	mrcal-calibrate-cameras			\
	mrcal-convert-lensmodel			\
	mrcal-show-distortion-off-pinhole	\
	mrcal-show-splined-model-correction	\
	mrcal-show-projection-uncertainty	\
	mrcal-show-projection-diff		\
	mrcal-reproject-points			\
	mrcal-reproject-image			\
	mrcal-graft-models			\
	mrcal-to-cahvor				\
	mrcal-from-cahvor			\
	mrcal-show-geometry			\
	mrcal-show-valid-intrinsics-region	\
	mrcal-is-within-valid-intrinsics-region \
	mrcal-triangulate			\
	mrcal-cull-corners                      \
	mrcal-show-residuals-board-observation  \
	mrcal-show-residuals                    \
	mrcal-stereo

# generate manpages from distributed binaries, and ship them. This is a hoaky
# hack because apparenly manpages from python tools is a crazy thing to want to
# do
DIST_MAN := $(addsuffix .1,$(DIST_BIN))

# parser
cameramodel-parser_GENERATED.c: cameramodel-parser.re mrcal.h
	re2c $< > $@.tmp && mv $@.tmp $@
LIB_SOURCES += cameramodel-parser_GENERATED.c
EXTRA_CLEAN += cameramodel-parser_GENERATED.c
cameramodel-parser_GENERATED.o: CCXXFLAGS += -fno-fast-math

ALL_NPSP_EXTENSION_MODULES := $(patsubst %-genpywrap.py,%,$(wildcard *-genpywrap.py))
ifeq (${USE_LIBELAS},) # not using libelas
ALL_NPSP_EXTENSION_MODULES := $(filter-out elas,$(ALL_NPSP_EXTENSION_MODULES))
endif
ALL_PY_EXTENSION_MODULES   := _mrcal $(patsubst %,_%_npsp,$(ALL_NPSP_EXTENSION_MODULES))
%/:
	mkdir -p $@

######### python stuff
%-npsp-pywrap-GENERATED.c: %-genpywrap.py
	python3 $< > $@.tmp && mv $@.tmp $@
mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@

ALL_NPSP_C  := $(patsubst %,%-npsp-pywrap-GENERATED.c,$(ALL_NPSP_EXTENSION_MODULES))
ALL_NPSP_O  := $(patsubst %,%-npsp-pywrap-GENERATED.o,$(ALL_NPSP_EXTENSION_MODULES))
ALL_NPSP_SO := $(patsubst %,mrcal/_%_npsp$(PY_EXT_SUFFIX),$(ALL_NPSP_EXTENSION_MODULES))

EXTRA_CLEAN += $(ALL_NPSP_C)

# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=95635
$(ALL_NPSP_O): CFLAGS += -Wno-array-bounds

mrcal-pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so
	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@
# Needed on Debian. Unnecessary, but harmless on Arch Linux
mrcal-pywrap.o: CFLAGS += -I/usr/include/suitesparse
PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)

# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
# and the compiler complains. But that's how Python does it! So I tell the
# compiler to chill
$(PYTHON_OBJECTS): CFLAGS += -Wno-cast-function-type
$(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)

# The python libraries (compiled ones and ones written in python) all live in
# mrcal/
DIST_PY3_MODULES := mrcal

all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
EXTRA_CLEAN += mrcal/*.so

include Makefile.doc
include Makefile.tests

include mrbuild/Makefile.common.footer

=== debian/changelog ===
mrcal (2.2-4) unstable; urgency=medium

  * Cleaned up Build-Depends to work with the nocheck profile and to
    cross-build successfully (Closes: #1029083)

 -- Dima Kogan <dkogan@debian.org>  Tue, 17 Jan 2023 09:55:00 -0800

mrcal (2.2-3) focal; urgency=medium

  * Disabled mrcal-convert-lensmodel test to fix intermittent test failure

 -- Dima Kogan <dkogan@debian.org>  Tue, 25 Oct 2022 12:11:49 -0700

mrcal (2.2-2) unstable; urgency=medium

  * more tries in test-convert-lensmodel to fix test failure

 -- Dima Kogan <dkogan@debian.org>  Wed, 05 Oct 2022 21:57:00 -0700

mrcal (2.2-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 03 Oct 2022 21:18:47 -0700

=== debian/control ===
--- 
+++ 
@@ -8,17 +8,23 @@
  dh-python,
  libdogleg-dev (>= 0.15.4),
  libsuitesparse-dev (>= 1:4.5.2),
- perl:native, liblist-moreutils-perl:native,
+ libfreeimage-dev,
+ perl:any,
+ liblist-moreutils-perl:native,
  vnlog,
  chrpath,
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
-# These are for the tests only, so :native
+# Needed for *-genpywrap.py. Need arch:build for tests, but testing while
+# cross-building doesn't work anyway
+ python3-numpy:native,
+# Need this even when not running tests: *-genpywrap.py uses npsp
+ python3-numpysane (>= 0.35),
+ mrbuild,
+# These are for the tests only
  python3-gnuplotlib (>= 0.38) <!nocheck>,
- python3-numpysane (>= 0.35)  <!nocheck>,
  python3-opencv               <!nocheck>,
- python3-numpy                <!nocheck>,
  python3-scipy (>= 0.18)      <!nocheck>
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
@@ -47,6 +53,8 @@
          python3-scipy (>= 0.18),  python3-ipython,
          python3-opencv, python3,
          mrgingham (>= 1.5)
+Recommends: python3-fltk,
+            python3-gl-image-display
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on

=== debian/watch ===
version=4
https://github.com/dkogan/mrcal/tags .*/v?(\d\S+)\.tar\.gz

## mrcal 2.3

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,6 @@
+include choose_mrbuild.mk
+include $(MRBUILD_MK)/Makefile.common.header
+
 # "0" or undefined means "false"
 # everything else means  "true"
 
@@ -11,12 +14,9 @@
 # to print them all: $(foreach v,$(filter USE_%,$(.VARIABLES)),$(warning $v = '${$v}'))
 
 
-
-include mrbuild/Makefile.common.header
-
 PROJECT_NAME := mrcal
-ABI_VERSION  := 2
-TAIL_VERSION := 2
+ABI_VERSION  := 3
+TAIL_VERSION := 0
 
 VERSION := $(VERSION_FROM_PROJECT)
 
@@ -24,10 +24,12 @@
   mrcal.c			\
   mrcal-opencv.c		\
   mrcal-image.c			\
+  stereo.c			\
   poseutils.c			\
   poseutils-opencv.c		\
   poseutils-uses-autodiff.cc	\
-  triangulation.cc
+  triangulation.cc              \
+  cahvore.cc
 
 ifneq (${USE_LIBELAS},) # using libelas
 LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
@@ -49,18 +51,23 @@
 CFLAGS    += --std=gnu99
 CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter
 
-mrcal.o test/test-cahvor.o: minimath/minimath_generated.h
+$(patsubst %.c,%.o,$(shell grep -l '#include .*minimath\.h' *.c */*.c)): minimath/minimath_generated.h
 minimath/minimath_generated.h: minimath/minimath_generate.pl
 	./$< > $@.tmp && mv $@.tmp $@
 EXTRA_CLEAN += minimath/minimath_generated.h
 
-DIST_INCLUDE += \
-	mrcal.h \
-	mrcal-image.h \
-	mrcal-internal.h \
-	basic-geometry.h \
-	poseutils.h \
-	triangulation.h
+DIST_INCLUDE +=			\
+	mrcal.h			\
+	mrcal-image.h		\
+	mrcal-internal.h	\
+	basic-geometry.h	\
+	poseutils.h		\
+	triangulation.h		\
+	mrcal-types.h		\
+	stereo.h
+
+
+
 DIST_BIN :=					\
 	mrcal-calibrate-cameras			\
 	mrcal-convert-lensmodel			\
@@ -105,8 +112,8 @@
 ######### python stuff
 %-npsp-pywrap-GENERATED.c: %-genpywrap.py
 	python3 $< > $@.tmp && mv $@.tmp $@
-mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so
-	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@
+mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so libmrcal.so.${ABI_VERSION}
+	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
 
 ALL_NPSP_C  := $(patsubst %,%-npsp-pywrap-GENERATED.c,$(ALL_NPSP_EXTENSION_MODULES))
 ALL_NPSP_O  := $(patsubst %,%-npsp-pywrap-GENERATED.o,$(ALL_NPSP_EXTENSION_MODULES))
@@ -118,8 +125,8 @@
 $(ALL_NPSP_O): CFLAGS += -Wno-array-bounds
 
 mrcal-pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
-mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so
-	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $(PY_MRBUILD_LDFLAGS) $< -lmrcal -o $@
+mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so libmrcal.so.${ABI_VERSION}
+	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
 # Needed on Debian. Unnecessary, but harmless on Arch Linux
 mrcal-pywrap.o: CFLAGS += -I/usr/include/suitesparse
 PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)
@@ -140,4 +147,4 @@
 include Makefile.doc
 include Makefile.tests
 
-include mrbuild/Makefile.common.footer
+include $(MRBUILD_MK)/Makefile.common.footer

=== debian/changelog ===
mrcal (2.3-4) unstable; urgency=medium

  * Explicitly linking with libsuitesparseconfig. Adds explicit dependency
    that makes it harder to end up with incompatible packages

 -- Dima Kogan <dkogan@debian.org>  Wed, 06 Sep 2023 21:51:00 -0700

mrcal (2.3-3) unstable; urgency=medium

  * Tightened libdogleg-dev version dependency

 -- Dima Kogan <dkogan@debian.org>  Sat, 22 Jul 2023 21:46:39 -0700

mrcal (2.3-2) unstable; urgency=medium

  * Build with latest suitesparse packages

 -- Dima Kogan <dkogan@debian.org>  Tue, 18 Jul 2023 22:50:02 -0700

mrcal (2.3-1) unstable; urgency=medium

  * New upstream release
  * New C library package for the updated ABI: libmrcal3

 -- Dima Kogan <dkogan@debian.org>  Thu, 04 May 2023 22:38:49 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
- libdogleg-dev (>= 0.15.4),
+ libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
  libfreeimage-dev,
  perl:any,
@@ -34,7 +34,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal2
+Package: libmrcal3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -47,7 +47,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -65,7 +65,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal2 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal3 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -76,7 +76,7 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal2 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),

## mrcal 2.4.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 include choose_mrbuild.mk
 include $(MRBUILD_MK)/Makefile.common.header
+
 
 # "0" or undefined means "false"
 # everything else means  "true"
@@ -15,7 +16,7 @@
 
 
 PROJECT_NAME := mrcal
-ABI_VERSION  := 3
+ABI_VERSION  := 4
 TAIL_VERSION := 0
 
 VERSION := $(VERSION_FROM_PROJECT)
@@ -49,7 +50,7 @@
 endif
 
 CFLAGS    += --std=gnu99
-CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter
+CCXXFLAGS += -Wno-missing-field-initializers -Wno-unused-variable -Wno-unused-parameter -Wno-missing-braces
 
 $(patsubst %.c,%.o,$(shell grep -l '#include .*minimath\.h' *.c */*.c)): minimath/minimath_generated.h
 minimath/minimath_generated.h: minimath/minimath_generate.pl
@@ -80,6 +81,9 @@
 	mrcal-graft-models			\
 	mrcal-to-cahvor				\
 	mrcal-from-cahvor			\
+	mrcal-to-kalibr				\
+	mrcal-from-kalibr			\
+	mrcal-from-ros				\
 	mrcal-show-geometry			\
 	mrcal-show-valid-intrinsics-region	\
 	mrcal-is-within-valid-intrinsics-region \
@@ -93,6 +97,9 @@
 # hack because apparenly manpages from python tools is a crazy thing to want to
 # do
 DIST_MAN := $(addsuffix .1,$(DIST_BIN))
+
+# if using an older mrbuild SO won't be defined, and we need it
+SO ?= so
 
 # parser
 cameramodel-parser_GENERATED.c: cameramodel-parser.re mrcal.h
@@ -112,7 +119,7 @@
 ######### python stuff
 %-npsp-pywrap-GENERATED.c: %-genpywrap.py
 	python3 $< > $@.tmp && mv $@.tmp $@
-mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.so libmrcal.so.${ABI_VERSION}
+mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
 
 ALL_NPSP_C  := $(patsubst %,%-npsp-pywrap-GENERATED.c,$(ALL_NPSP_EXTENSION_MODULES))
@@ -125,10 +132,10 @@
 $(ALL_NPSP_O): CFLAGS += -Wno-array-bounds
 
 mrcal-pywrap.o: $(addsuffix .h,$(wildcard *.docstring))
-mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.so libmrcal.so.${ABI_VERSION}
-	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -o $@
-# Needed on Debian. Unnecessary, but harmless on Arch Linux
-mrcal-pywrap.o: CFLAGS += -I/usr/include/suitesparse
+mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
+	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
+
+CFLAGS += -I/usr/include/suitesparse
 PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)
 
 # In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
@@ -142,7 +149,7 @@
 DIST_PY3_MODULES := mrcal
 
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
-EXTRA_CLEAN += mrcal/*.so
+EXTRA_CLEAN += mrcal/*.$(SO)
 
 include Makefile.doc
 include Makefile.tests

=== debian/changelog ===
mrcal (2.4.1-4build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 17:45:46 +0000

mrcal (2.4.1-4build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 14:22:32 +0000

mrcal (2.4.1-4) unstable; urgency=medium

  * Team upload.
  * Workaround for NumPy 2

 -- Timo Röhling <roehling@debian.org>  Wed, 29 Jan 2025 22:46:29 +0100

mrcal (2.4.1-3) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080677)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 19:17:50 -0700

mrcal (2.4.1-2) unstable; urgency=medium

  * Removed unintended symbol export

  * Initialize Python objects more properly to fix build failure in gcc-14
    (Closes: #1075295)

 -- Dima Kogan <dkogan@debian.org>  Sat, 06 Jul 2024 22:16:47 -0700

mrcal (2.4.1-1) unstable; urgency=medium

  * New upstream release
    Bug fixes in mrcal-stereo

 -- Dima Kogan <dkogan@debian.org>  Tue, 13 Feb 2024 22:21:44 -0800

mrcal (2.4-1) unstable; urgency=medium

  * New upstream release
  * ABI bump: libmrcal4

 -- Dima Kogan <dkogan@debian.org>  Mon, 22 Jan 2024 18:15:37 -0800

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,9 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080677
+ python3-setuptools,
  libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
  libfreeimage-dev,
@@ -20,7 +23,9 @@
 # cross-building doesn't work anyway
  python3-numpy:native,
 # Need this even when not running tests: *-genpywrap.py uses npsp
- python3-numpysane (>= 0.35),
+# Need at least 0.37 for the interactive pixel picking in mrcal-stereo to
+# work
+ python3-numpysane (>= 0.37),
  mrbuild,
 # These are for the tests only
  python3-gnuplotlib (>= 0.38) <!nocheck>,
@@ -34,7 +39,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal3
+Package: libmrcal4
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -47,7 +52,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -65,7 +70,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal3 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal4 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -76,13 +81,15 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal3 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),
          python3-shapely, python3-ipython,
 # for image_transformation_map(), not for plotting
-         python3-matplotlib
+         python3-matplotlib,
+# for reading/writing kalibr model files
+         python3-yaml
 Provides: ${python3:Provides}
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
 
 export VERSION_USE_LATEST_TAG  = 1

## mrcal 2.5

=== Makefile ===
--- 
+++ 
@@ -16,21 +16,69 @@
 
 
 PROJECT_NAME := mrcal
-ABI_VERSION  := 4
+ABI_VERSION  := 5
 TAIL_VERSION := 0
 
-VERSION := $(VERSION_FROM_PROJECT)
+VERSION = $(VERSION_FROM_PROJECT)
 
 LIB_SOURCES +=			\
   mrcal.c			\
-  mrcal-opencv.c		\
-  mrcal-image.c			\
+  opencv.c			\
+  uncertainty.c			\
+  image.c			\
   stereo.c			\
   poseutils.c			\
   poseutils-opencv.c		\
   poseutils-uses-autodiff.cc	\
   triangulation.cc              \
-  cahvore.cc
+  cahvore.cc                    \
+  traverse-sensor-links.c       \
+  heap.cc                       \
+  python-cameramodel-converter.c
+
+
+# This is a utility function for external Python wrapping. I link this into
+# libmrcal.so, but libmrcal.so does NOT link with libpython. 99% of the usage of
+# libmrcal.so will not use this, so it should work without libpython. People
+# using this function will be doing so as part of PyArg_ParseTupleAndKeywords(),
+# so they will be linking to libpython anyway. Thus I weaken all the references
+# to libpython here. c_build_rule is the default logic in mrbuild
+#
+# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
+# --weaken works to weaken the symbols after compiling. With older objcopy (not
+# sure which), the objcopy command completes successfully, but it doesn't
+# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
+# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
+# symbols. I can't do this on the first pass because before compiling even once
+# I don't know which Py symbols I'm going to get (some are generated by the
+# Python internals).
+#
+# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
+# clang: the references produced by inline functions in Python.h that *I* am not
+# calling are not weakened. I catch this case here, and throw an error. In the
+# very near future, few people are going to have the too-old binutils, and we'll
+# be done
+python-cameramodel-converter.o: %.o:%.c
+	$(c_build_rule) && mv $@ _$@
+	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
+	$(NM) --undef _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
+	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
+	  < python-cameramodel-converter-py-symbol-refs					\
+	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
+	  > python-cameramodel-converter-py-symbol-refs.h				\
+	  &&										\
+	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
+	  if $(NM) --undef $@ | grep -E -q '\sU\s+_?Py'; then				\
+	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
+	    false;									\
+	  fi										\
+	else										\
+	  mv _$@ $@;									\
+	fi
+EXTRA_CLEAN += \
+  python-cameramodel-converter-py-symbol-refs   \
+  python-cameramodel-converter-py-symbol-refs.h \
+  _python-cameramodel-converter.o
 
 ifneq (${USE_LIBELAS},) # using libelas
 LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
@@ -38,12 +86,13 @@
 
 
 BIN_SOURCES +=					\
-  test-gradients.c				\
+  test/test-gradients.c				\
   test/test-cahvor.c				\
   test/test-lensmodel-string-manipulation.c     \
-  test/test-parser-cameramodel.c
-
-LDLIBS += -ldogleg -lfreeimage
+  test/test-parser-cameramodel.c                \
+  test/test-heap.c
+
+LDLIBS += -ldogleg -lstb -lpng -ljpeg -llapack
 
 ifneq (${USE_LIBELAS},) # using libelas
 LDLIBS += -lelas
@@ -59,13 +108,15 @@
 
 DIST_INCLUDE +=			\
 	mrcal.h			\
-	mrcal-image.h		\
-	mrcal-internal.h	\
+	image.h			\
+	internal.h		\
 	basic-geometry.h	\
 	poseutils.h		\
 	triangulation.h		\
-	mrcal-types.h		\
-	stereo.h
+	types.h			\
+	stereo.h                \
+	heap.h                  \
+	python-cameramodel-converter.h
 
 
 
@@ -136,12 +187,8 @@
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
 
 CFLAGS += -I/usr/include/suitesparse
-PYTHON_OBJECTS := mrcal-pywrap.o $(ALL_NPSP_O)
-
-# In the python api I have to cast a PyCFunctionWithKeywords to a PyCFunction,
-# and the compiler complains. But that's how Python does it! So I tell the
-# compiler to chill
-$(PYTHON_OBJECTS): CFLAGS += -Wno-cast-function-type
+PYTHON_OBJECTS := mrcal-pywrap.o python-cameramodel-converter.o $(ALL_NPSP_O)
+
 $(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)
 
 # The python libraries (compiled ones and ones written in python) all live in
@@ -151,7 +198,18 @@
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
 EXTRA_CLEAN += mrcal/*.$(SO)
 
+
+TESTS_ALL_TARGETS := test-all test-nosampling test-triangulation-uncertainty test-external-data
+$(TESTS_ALL_TARGETS): all
+	./test.sh $@
+.PHONY: $(TESTS_ALL_TARGETS)
+test:
+	@echo "Which test set should we run? I know about '$(TESTS_ALL_TARGETS)'" > /dev/stderr; false
+.PHONY: test
+
 include Makefile.doc
-include Makefile.tests
 
 include $(MRBUILD_MK)/Makefile.common.footer
+
+# to work with mrbuild < 1.14
+OBJCOPY ?= objcopy

=== debian/changelog ===
mrcal (2.5-3) unstable; urgency=medium

  * Patches to fix oversight bugs
    - Shipping extra tools
    - Working across Python versions

 -- Dima Kogan <dkogan@debian.org>  Wed, 31 Dec 2025 00:17:58 -0800

mrcal (2.5-2) unstable; urgency=medium

  * Patches to fix bugs exposed by buildd test failures
    - Slightly looser numerical thresholds
    - We account for endianness mismatches for data read from files on disk

 -- Dima Kogan <dkogan@debian.org>  Sun, 28 Dec 2025 19:33:56 -0800

mrcal (2.5-1) unstable; urgency=medium

  * New upstream release
    No more dependence on libfreeimage-dev. Replaced with Build-Depends:
    libstb-dev,libjpeg-dev,libpng-dev

 -- Dima Kogan <dkogan@debian.org>  Fri, 26 Dec 2025 21:01:01 -0800

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,16 @@
 # with older debian-based distros
  debhelper (>= 11),
  dh-python,
+# to get the host ARCH-pkgconf into the PKG_CONFIG variable
+ pkgconf,
 # for "make install" to work. See
 #   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080677
  python3-setuptools,
  libdogleg-dev (>= 0.16-4),
  libsuitesparse-dev (>= 1:4.5.2),
- libfreeimage-dev,
+ libstb-dev,
+ libjpeg-dev,
+ libpng-dev,
  perl:any,
  liblist-moreutils-perl:native,
  vnlog,
@@ -19,6 +23,7 @@
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
+ python3-numpy-dev,
 # Needed for *-genpywrap.py. Need arch:build for tests, but testing while
 # cross-building doesn't work anyway
  python3-numpy:native,
@@ -26,8 +31,10 @@
 # Need at least 0.37 for the interactive pixel picking in mrcal-stereo to
 # work
  python3-numpysane (>= 0.37),
- mrbuild,
+ mrbuild (>= 1.14),
+ binutils-for-host,
 # These are for the tests only
+ zsh                          <!nocheck>,
  python3-gnuplotlib (>= 0.38) <!nocheck>,
  python3-opencv               <!nocheck>,
  python3-scipy (>= 0.18)      <!nocheck>
@@ -39,7 +46,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/mrcal
 Testsuite: autopkgtest-pkg-python
 
-Package: libmrcal4
+Package: libmrcal5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -52,7 +59,7 @@
 
 Package: mrcal
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal5 (= ${binary:Version}),
          python3-mrcal (= ${binary:Version}),
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-scipy (>= 0.18),  python3-ipython,
@@ -70,7 +77,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libmrcal4 (= ${binary:Version})
+Depends: ${misc:Depends}, libmrcal5 (= ${binary:Version})
 Description: Calibration and SFM library
  A photogrammetry toolkit that provides improved methods for making and using
  camera models (calibration, tracking, mapping, etc). The focus is on
@@ -81,7 +88,7 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal4 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libmrcal5 (= ${binary:Version}),
          ${python3:Depends},
          python3-gnuplotlib (>= 0.38), python3-numpysane (>= 0.35),
          python3-opencv, python3-numpy, python3-scipy (>= 0.18),

=== debian/watch ===
version=4
opts=\
uversionmangle=s/pre/~/ \
https://github.com/dkogan/mrcal/tags .*/v(\d\S+)\.tar\.gz

## mrcal 2.5.1

=== Makefile ===
--- 
+++ 
@@ -9,9 +9,13 @@
 # on anything in non-free, so I default to not using libelas
 USE_LIBELAS ?= 0
 
+# If true, we compile libstb into image.o and libmrcal.so. If false, we link to
+# an external libstb.so. We default to building it ourselves on macos and using
+# the library otherwise
+USE_LOCAL_STB_IMPLEMENTATION ?= $(COND_DARWIN)
 
 # convert all USE_XXX:=0 to an empty string
-$(foreach v,$(filter USE_%,$(.VARIABLES)),$(if $(filter 0,${$v}),$(eval undefine $v)))
+$(foreach v,$(filter USE_%,$(.VARIABLES)),$(if $(filter 0,${$v}),$(eval $v :=)))
 # to print them all: $(foreach v,$(filter USE_%,$(.VARIABLES)),$(warning $v = '${$v}'))
 
 
@@ -37,53 +41,13 @@
   python-cameramodel-converter.c
 
 
-# This is a utility function for external Python wrapping. I link this into
-# libmrcal.so, but libmrcal.so does NOT link with libpython. 99% of the usage of
-# libmrcal.so will not use this, so it should work without libpython. People
-# using this function will be doing so as part of PyArg_ParseTupleAndKeywords(),
-# so they will be linking to libpython anyway. Thus I weaken all the references
-# to libpython here. c_build_rule is the default logic in mrbuild
-#
-# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
-# --weaken works to weaken the symbols after compiling. With older objcopy (not
-# sure which), the objcopy command completes successfully, but it doesn't
-# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
-# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
-# symbols. I can't do this on the first pass because before compiling even once
-# I don't know which Py symbols I'm going to get (some are generated by the
-# Python internals).
-#
-# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
-# clang: the references produced by inline functions in Python.h that *I* am not
-# calling are not weakened. I catch this case here, and throw an error. In the
-# very near future, few people are going to have the too-old binutils, and we'll
-# be done
-python-cameramodel-converter.o: %.o:%.c
-	$(c_build_rule) && mv $@ _$@
-	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
-	$(NM) --undef _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
-	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
-	  < python-cameramodel-converter-py-symbol-refs					\
-	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
-	  > python-cameramodel-converter-py-symbol-refs.h				\
-	  &&										\
-	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
-	  if $(NM) --undef $@ | grep -E -q '\sU\s+_?Py'; then				\
-	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
-	    false;									\
-	  fi										\
-	else										\
-	  mv _$@ $@;									\
-	fi
-EXTRA_CLEAN += \
-  python-cameramodel-converter-py-symbol-refs   \
-  python-cameramodel-converter-py-symbol-refs.h \
-  _python-cameramodel-converter.o
-
 ifneq (${USE_LIBELAS},) # using libelas
 LIB_SOURCES := $(LIB_SOURCES) stereo-matching-libelas.cc
 endif
 
+ifneq ($(USE_LOCAL_STB_IMPLEMENTATION),)
+image.o: CFLAGS += -DSTB_IMAGE_IMPLEMENTATION=1
+endif
 
 BIN_SOURCES +=					\
   test/test-gradients.c				\
@@ -92,7 +56,7 @@
   test/test-parser-cameramodel.c                \
   test/test-heap.c
 
-LDLIBS += -ldogleg -lstb -lpng -ljpeg -llapack
+LDLIBS += -ldogleg $(if $(USE_LOCAL_STB_IMPLEMENTATION),,-lstb) -lpng -ljpeg -llapack
 
 ifneq (${USE_LIBELAS},) # using libelas
 LDLIBS += -lelas
@@ -127,6 +91,8 @@
 	mrcal-show-splined-model-correction	\
 	mrcal-show-projection-uncertainty	\
 	mrcal-show-projection-diff		\
+	mrcal-show-model-resolution		\
+	mrcal-show-stereo-pair-diff		\
 	mrcal-reproject-points			\
 	mrcal-reproject-image			\
 	mrcal-graft-models			\
@@ -168,6 +134,67 @@
 	mkdir -p $@
 
 ######### python stuff
+
+# python-cameramodel-converter contains a utility function for external Python
+# wrapping. I link this into libmrcal.so, but libmrcal.so does NOT link with
+# libpython. 99% of the usage of libmrcal.so will not use this, so it should
+# work without libpython. People using this function will be doing so as part of
+# PyArg_ParseTupleAndKeywords(), so they will be linking to libpython anyway.
+# Thus I weaken all the references to libpython here. c_build_rule is the
+# default logic in mrbuild
+#
+# This is a DEEP rabbithole. With Debian/trixie (released summer 2025) objcopy
+# --weaken works to weaken the symbols after compiling. With older objcopy (not
+# sure which), the objcopy command completes successfully, but it doesn't
+# actually weaken the symbols. I thus run nm to find the non-weakened symbols;
+# if any remain, I recompile, explicitly setting __attribute__((weak)) on these
+# symbols. I can't do this on the first pass because before compiling even once
+# I don't know which Py symbols I'm going to get (some are generated by the
+# Python internals).
+#
+# Finally, the second-pass-recompile-with-attribute-weak doesn't work with
+# clang: the references produced by inline functions in Python.h that *I* am not
+# calling are not weakened. I catch this case here, and throw an error. In the
+# very near future, few people are going to have the too-old binutils, and we'll
+# be done
+#
+# The above is all for Linux. On macos weak symbols are more work. The userspace
+# tools aren't available, and I THINK the semantics aren't the same. But I can
+# tell the loader to allow undefined references to exist, if those functions
+# aren't called. I pass that option, and I'm done
+ifneq ($(COND_DARWIN),)
+   $(info libmrcal.$(SO): LDFLAGS += -Wl,-undefined,dynamic_lookup)
+   libmrcal.$(SO): LDFLAGS += -Wl,-undefined,dynamic_lookup
+else
+
+python-cameramodel-converter.o: %.o:%.c
+	$(c_build_rule) && mv $@ _$@
+	$(OBJCOPY) --wildcard --weaken-symbol='Py*' --weaken-symbol='_Py*' _$@ $@ && mv $@ _$@
+	$(NM) -u _$@ | awk '$$1 == "U" && $$2 ~ "Py" { print $$2 }' > python-cameramodel-converter-py-symbol-refs
+	if [ -s python-cameramodel-converter-py-symbol-refs ]; then			\
+	  < python-cameramodel-converter-py-symbol-refs					\
+	    awk 'BEGIN {ORS=""; print "#define PY_REFS(_) " } {print "_("$$1") "} '	\
+	  > python-cameramodel-converter-py-symbol-refs.h				\
+	  &&										\
+	  $(c_build_rule) -DWEAKEN_PY_REFS;						\
+	  if $(NM) -u $@ | grep -E -q '\sU\s+_?Py'; then				\
+	    echo "ERROR: Strong symbols remain! See the Makefile for notes";		\
+	    false;									\
+	  fi										\
+	else										\
+	  mv _$@ $@;									\
+	fi
+EXTRA_CLEAN += \
+  python-cameramodel-converter-py-symbol-refs   \
+  python-cameramodel-converter-py-symbol-refs.h \
+  _python-cameramodel-converter.o
+
+
+endif
+
+
+
+
 %-npsp-pywrap-GENERATED.c: %-genpywrap.py
 	python3 $< > $@.tmp && mv $@.tmp $@
 mrcal/_%_npsp$(PY_EXT_SUFFIX): %-npsp-pywrap-GENERATED.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
@@ -186,7 +213,6 @@
 mrcal/_mrcal$(PY_EXT_SUFFIX): mrcal-pywrap.o libmrcal.$(SO) libmrcal.$(SO).${ABI_VERSION}
 	$(PY_MRBUILD_LINKER) $(PY_MRBUILD_LDFLAGS) $(LDFLAGS) $< -lmrcal -lsuitesparseconfig -o $@
 
-CFLAGS += -I/usr/include/suitesparse
 PYTHON_OBJECTS := mrcal-pywrap.o python-cameramodel-converter.o $(ALL_NPSP_O)
 
 $(PYTHON_OBJECTS): CFLAGS += $(PY_MRBUILD_CFLAGS)
@@ -196,7 +222,7 @@
 DIST_PY3_MODULES := mrcal
 
 all: mrcal/_mrcal$(PY_EXT_SUFFIX) $(ALL_NPSP_SO)
-EXTRA_CLEAN += mrcal/*.$(SO)
+EXTRA_CLEAN += mrcal/*$(PY_EXT_SUFFIX)
 
 
 TESTS_ALL_TARGETS := test-all test-nosampling test-triangulation-uncertainty test-external-data

=== debian/changelog ===
mrcal (2.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 09 Jan 2026 17:21:44 -0800

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,6 @@
  libpng-dev,
  perl:any,
  liblist-moreutils-perl:native,
- vnlog,
- chrpath,
  re2c (>= 2),
  python3-all-dev:any,
  libpython3-all-dev,
@@ -34,6 +32,7 @@
  mrbuild (>= 1.14),
  binutils-for-host,
 # These are for the tests only
+ vnlog                        <!nocheck>,
  zsh                          <!nocheck>,
  python3-gnuplotlib (>= 0.38) <!nocheck>,
  python3-opencv               <!nocheck>,
